Subject: Re: [PATCH 2/2] vhost_net: a kernel-level virtio server

From: Anthony Liguori <[email-masked]>
Date: Wed, 12 Aug 2009 14:27:31 -0500

Arnd Bergmann wrote:
>> As I pointed out earlier, most code in virtio net is asymmetrical: guest
>> provides buffers, host consumes them.  Possibly, one could use virtio
>> rings in a symmetrical way, but support of existing guest virtio net
>> means there's almost no shared code.
>>     
>
> The trick is to swap the virtqueues instead. virtio-net is actually
> mostly symmetric in just the same way that the physical wires on a
> twisted pair ethernet are symmetric (I like how that analogy fits).
>   

It's already been done between two guests.  See 
http://article.gmane.org/gmane.linux.kernel.virtualization/5423

Regards,

Anthony Liguori